# Cyborg

> `Cyborg` is an absolute nightmare.
> A twisted factory.
> A disgusting Enmanglement.
> A perfect melding of terrifying machinic heartlessness and disappointing human fallacy.
> A repulsive reaper of all of human consciousness -- but mostly SIGGRAPH presentations.
> H.R Giger's irreconcilable reality... if H.R. Giger was a computer programmer.

Cyborg is a free-form rendering engine that we mash whatever we feel like into.
It's a test bed for all sorts of modern rendering technology. Our goal is to take
techniques and features from modern game engines and reimplement them on our own, for
the sake of education, performance, and reusability. We wanna *make shit work.*

We also want to give artists a playground for generating all sorts of unique
3D visuals -- custom shaders, procedurally generated meshes and textures,
and a focus on *interesting* visuals.
Realism is a non-goal!
Make shrooms obsolete.
Go wild.

Modularity and reusability are important. We wanna be able to unplug certain
parts of the rendering pipeline, upgrade them, fix them, document them, commit
them, tag them, etc., then stick them back in in a different place to end up
with a different resulting image.

Cyborg is licensed under the GPL-3.0. Yes, this does mean that Bevy games using
Cyborg will be required to make their source code public. But it also means that
new visuals added to Cyborg will become available to all other developers and
artists to use. Hopefully, this will expand the collective knowledge of how different
rendering effects work, and decrease the pressure on graphics programmers to
reimplement the exact same graphical effects in different games over and over and
over again. In the future, Cyborg will have a vast variety of visuals in its toolbox,
gathered from countless programmers and individual projects.

> We will add your biological and technological distinctiveness to our own.
> Resistance is futile.
>
> -- The Borg

Cyborg is based on [Bevy](https://bevyengine.org/), a "refreshingly simple"
game engine written in Rust. Bevy provides a lot of useful utilities like
ECS-based data parallelization and a modular plugin system. Cyborg is integrated
into the rest of the Bevy ecosystem, and can also work as a replacement Bevy's
provided rendering engine, giving Bevy games GPU-powered, procedurally-generated
content and access to modern rendering optimizations.